summaryrefslogtreecommitdiff
path: root/tests/misc/seq
diff options
context:
space:
mode:
authorJim Meyering <jim@meyering.net>2007-09-10 19:01:39 +0200
committerJim Meyering <jim@meyering.net>2007-09-15 08:40:39 +0200
commitd62bdb30f7ee8114162239178bc077ea81ecac38 (patch)
tree49ec1bb2d9f713a93a48c8074f3a7c32d824f652 /tests/misc/seq
parentbe23f60132655a40bc65fc8437509ec02663d1be (diff)
downloadcoreutils-d62bdb30f7ee8114162239178bc077ea81ecac38.tar.xz
Move the sole test in tests/seq to tests/misc/seq.
* tests/seq/basic: Move this file to ... * tests/misc/seq: ...here. Don't rely on $PROG in env. * tests/misc/Makefile.am (TESTS): Add seq. * tests/Makefile.am (SUBDIRS): Remove seq. * tests/seq: Remove the directory. * configure.ac (AC_CONFIG_FILES): Remove tests/seq/Makefile
Diffstat (limited to 'tests/misc/seq')
-rwxr-xr-xtests/misc/seq100
1 files changed, 100 insertions, 0 deletions
diff --git a/tests/misc/seq b/tests/misc/seq
new file mode 100755
index 000000000..2d662c39c
--- /dev/null
+++ b/tests/misc/seq
@@ -0,0 +1,100 @@
+#!/bin/sh
+# -*- perl -*-
+# Test "seq".
+
+# Copyright (C) 1999, 2000, 2003, 2005-2007 Free Software Foundation, Inc.
+
+# This program is free software: you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation, either version 3 of the License, or
+# (at your option) any later version.
+
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+
+# You should have received a copy of the GNU General Public License
+# along with this program. If not, see <http://www.gnu.org/licenses/>.
+
+: ${PERL=perl}
+: ${srcdir=.}
+
+$PERL -e 1 > /dev/null 2>&1 || {
+ echo 1>&2 "$0: configure didn't find a usable version of Perl," \
+ "so can't run this test"
+ exit 77
+}
+
+me=`echo $0|sed 's,.*/,,'`
+exec $PERL -w -I$srcdir/.. -MCoreutils -M"CuTmpdir qw($me)" -- - << \EOF
+require 5.003;
+use strict;
+
+(my $program_name = $0) =~ s|.*/||;
+
+# Turn off localisation of executable's ouput.
+@ENV{qw(LANGUAGE LANG LC_ALL)} = ('C') x 3;
+
+my @Tests =
+ (
+ ['onearg-1', qw(10), {OUT => [(1..10)]}],
+ ['onearg-2', qw(-1)],
+ ['neg-1', qw(-10 10 10), {OUT => [qw(-10 0 10)]}],
+ # ['neg-2', qw(-.1 .1 .11), {OUT => [qw(-0.1 0.0 0.1)]}],
+ ['neg-3', qw(1 -1 0), {OUT => [qw(1 0)]}],
+ ['neg-4', qw(1 -1 -1), {OUT => [qw(1 0 -1)]}],
+
+ ['float-1', qw(0.8 0.1 0.9), {OUT => [qw(0.8 0.9)]}],
+ ['float-2', qw(0.1 0.99 1.99), {OUT => [qw(0.10 1.09)]}],
+ ['float-3', qw(10.8 0.1 10.95), {OUT => [qw(10.8 10.9)]}],
+ ['float-4', qw(0.1 -0.1 -0.2), {OUT => [qw(0.1 0.0 -0.1 -0.2)]}],
+ ['float-5', qw(0.8 1e-1 0.9), {OUT => [qw(0.8 0.9)]}],
+ ['float-6', qw(0.8 0.1 0.90000000000000000000), {OUT => [qw(0.8 0.9)]}],
+
+ ['wid-1', qw(.8 1e-2 .81), {OUT => [qw(0.80 0.81)]}],
+ ['wid-2', qw(.89999 1e-7 .8999901), {OUT => [qw(0.8999900 0.8999901)]}],
+
+ ['eq-wid-1', qw(-w 1 -1 -1), {OUT => [qw(01 00 -1)]}],
+ # Prior to 2.0g, this test would fail on e.g., HPUX systems
+ # because it'd end up using %3.1f as the format instead of %4.1f.
+ ['eq-wid-2', qw(-w -.1 .1 .11),{OUT => [qw(-0.1 00.0 00.1)]}],
+ ['eq-wid-3', qw(-w 1 3.0), {OUT => [qw(1 2 3)]}],
+ ['eq-wid-4', qw(-w .8 1e-2 .81), {OUT => [qw(0.80 0.81)]}],
+ ['eq-wid-5', qw(-w 1 .5 2), {OUT => [qw(1.0 1.5 2.0)]}],
+ ['eq-wid-6', qw(-w +1 2), {OUT => [qw(1 2)]}],
+ ['eq-wid-7', qw(-w " .1" " .1"), {OUT => [qw(0.1)]}],
+
+ # Prior to coreutils-4.5.11, some of these were not accepted.
+ ['fmt-1', qw(-f %2.1f 1.5 .5 2),{OUT => [qw(1.5 2.0)]}],
+ ['fmt-2', qw(-f %0.1f 1.5 .5 2),{OUT => [qw(1.5 2.0)]}],
+ ['fmt-3', qw(-f %.1f 1.5 .5 2),{OUT => [qw(1.5 2.0)]}],
+
+ ['fmt-4', qw(-f %3.0f 1 2), {OUT => [' 1', ' 2']}],
+ ['fmt-5', qw(-f %-3.0f 1 2), {OUT => ['1 ', '2 ']}],
+ ['fmt-6', qw(-f %+3.0f 1 2), {OUT => [' +1', ' +2']}],
+ ['fmt-7', qw(-f %0+3.0f 1 2), {OUT => [qw(+01 +02)]}],
+ ['fmt-8', qw(-f %0+.0f 1 2), {OUT => [qw(+1 +2)]}],
+ ['fmt-9', '-f "% -3.0f"', qw(-1 0), {OUT => ['-1 ', ' 0 ']}],
+ ['fmt-a', '-f "% -.0f"',qw(-1 0), {OUT => ['-1', ' 0']}],
+ );
+
+# Append a newline to each entry in the OUT array.
+my $t;
+foreach $t (@Tests)
+ {
+ my $e;
+ foreach $e (@$t)
+ {
+ $e->{OUT} = join ("\n", @{$e->{OUT}}) . "\n"
+ if ref $e eq 'HASH' and exists $e->{OUT};
+ }
+ }
+
+my $save_temps = $ENV{SAVE_TEMPS};
+my $verbose = $ENV{VERBOSE};
+my $prog = 'seq';
+
+my $fail = run_tests ($program_name, $prog, \@Tests, $save_temps, $verbose);
+exit $fail;
+EOF